<?php 
/*
  $Id: ec_diagnostics.php,v 0.3 2007/02/18 alexstudio Exp $

  Original code by Brian Burton - brian@dynamoeffects.com
  Modified to work with Express Checkout IPN payment module
  by AlexStudio

  Released under the GNU General Public License
*/
  include('includes/application_top.php');

  $ssl_detected = false;
  if (tep_not_null(getenv('HTTPS'))) {
    if (getenv('HTTPS') == 'on' || getenv('HTTPS') == '1') $ssl_detected = true;
  } else if (PHP_VERSION >= 4.3) {
    if (strtolower($_SERVER['HTTPS']) == 'on' || $_SERVER['SERVER_PORT'] == '443') $ssl_detected = true;
  } else if (getenv('SERVER_PORT') == '443') $ssl_detected = true;

  if (!$ssl_detected) {  
    if (ENABLE_SSL == true && HTTPS_SERVER != '') {
      if (isset($HTTP_GET_VARS['retry']) && isset($_SESSION['paypal_ec_diag']) && $_SESSION['paypal_ec_diag'] == $HTTP_GET_VARS['retry']) {
        $ssl_url = false;
      } else {
        $_SESSION['paypal_ec_diag'] = 1;
        tep_redirect(tep_href_link(basename($_SERVER['PHP_SELF']), 'retry=1', 'SSL', false, false));
      }
    } else $ssl_url = false;
  } else $ssl_url = true;
  if (isset($_SESSION['paypal_ec_diag'])) unset($_SESSION['paypal_ec_diag']);
  if (function_exists('openssl_pkcs7_sign') && function_exists('openssl_pkcs7_encrypt')) $ssl_error = false;
  else $ssl_error = true;

  function ec_parse_xml($text) {
    $reg_exp = '/<(\w+)[^>]*>(.*?)<\/\\1>/s';
    preg_match_all($reg_exp, $text, $match);
    foreach ($match[1] as $key=>$val) {
      if ( preg_match($reg_exp, $match[2][$key]) ) {
          $array[$val][] = ec_parse_xml($match[2][$key]);
      } else {
          $array[$val] = $match[2][$key];
      }
    }
    return $array;
  } 

  if (!$ssl_error) {
    $php_check = true;
    $curl_exists = true;
    $curl_works = true;
    $cert_exists = true;
    $cert_htaccess_exists = true;
    $user_exists = true;
    $pass_exists = true;
    $xml_exists = array('true', 'true', 'true', 'true');
    $curl_errors = '';

    $xml_documents = array('doExpressCheckout.xml',
                           'getExpressCheckoutDetails.xml',
                           'setExpressCheckout.xml',
                           'diagnostics.xml');

    $all_good = true;

    if (function_exists('version_compare')) {
      if (version_compare(phpversion(), '4.3.0') < 0) {
        $php_check = false;
        $all_good = false;
      }
    } else {
      $php_check = false;
      $all_good = false;
    }

    if (!function_exists('curl_init')) {
      $curl_exists = false;
      $all_good = false;
    }
    if ($curl_exists) {
      $ch = curl_init();
      @curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
      @curl_setopt($ch, CURLOPT_URL, "http://www.oscommerce.com");
      @curl_exec($ch);
      if (@curl_errno($ch) != 0) {
        $curl_works = false;
        $all_good = false;
        $curl_errors = curl_error($ch) . ' (Error No. ' . curl_errno($ch) . ')';
      }
      curl_close($ch);
    }
    if (!file_exists(MODULE_PAYMENT_PAYPAL_API_CERT_PATH)) {
      $cert_exists = false;
      $all_good = false;
    }
    if (trim(MODULE_PAYMENT_PAYPAL_API_USERNAME) == '') {
      $user_exists = false;
      $all_good = false;
    }
    if (trim(MODULE_PAYMENT_PAYPAL_API_PASSWORD) == '') {
      $pass_exists = false;
      $all_good = false;
    }
    for ($x = 0; $x < count($xml_documents); $x++) {
      if (!file_exists(DIR_WS_INCLUDES . 'ec_xml/' . $xml_documents[$x])) {
        $xml_exists[$x] = false;
        $all_good = false;
      }
    }
  }
?>
<html>
  <head>
    <title>PayPal Express Checkout API Diagnostics Program</title>
    <style>
      body { margin: 0px }
      table { font: 12px verdana }
      td.topHeader {font-family:verdana, Arial, Helvetica, Sans-serif; padding: 20px 11px 4px 0px;}
      td.topHeader H2 {font-size:26px; line-height:0px; color:#4B7EAD; margin:0px;}
      td.topHeader H3, td.topHeader H1 {font-size:18px; line-height:15px; color:#365A7C; font-weight:bold; margin:4px 0px 0px 0px;}
      td.good { color: #009900; font: 16px "arial black", arial, verdana }
      .error { color: #ff0000; font: 16px "arial black", arial, verdana }
      td.test_text { font-weight: bold; padding: 4px 0px 4px 0px }
      td.divider { font-size: 1px; height: 1px; padding: 0px; background-color: #EFEFEF }
    </style>
  </head>
  <body>
    <center>
      <table border=0 style="width:768px;text-align: left" cellspacing=0 cellpadding=0>
        <tr>
          <td class="topHeader" valign="middle" colspan="2"><h2>Paypal Express Checkout API</h2><br>
          <h1>Diagnostics Program</h1><br>Re-wrote for PayPal Express Checkout IPN<br>
          <b>by AlexStudio</b><br>Original code for PayPal Website Payment Pro<br>by Brian Burton (dynamoeffects)</td>
        </tr>
<?php
  if ($ssl_error) {
?>
        <tr>
          <td style="height: 20px"></td>
        </tr>
        <tr>
          <td colspan="2" class="topHeader" valign="middle" style="border: 2px solid #FF0000; padding: 20px"><center><h2><span style="color: #FF0000">OpenSSL Not Detected!</span></h2></center><br><h1><span style="line-height: 20px">The required OpenSSL functions not detected.<br><br>PayPal Express Checkout IPN module won't work without OpenSSL installed.<br><br> Please contact your host for OpenSSL installation. A dedicated or shared SSL certificate is highly recommended.</span></h1></td>
        </tr>
<?php
  } else {
?>
        <tr>
          <td class="topHeader" valign="middle" colspan="2"><h1>Basic Tests</h1></td>
        </tr>
        <tr><td class="divider" colspan="2"></td></tr>
        <tr>
          <td class="test_text">Using at least PHP 4.3.0?</td>
          <td align="center" class="<?php echo ($php_check ? 'good' : 'error'); ?>"><?php echo ($php_check ? 'Yes' : 'No'); ?></td>
        </tr>
        <tr><td class="divider" colspan="2"></td></tr>
        <tr>
          <td class="test_text">Is OpenSSL installed?</td>
          <td align="center" class="good">Yes</td>
        </tr>
        <tr><td class="divider" colspan="2"></td></tr>
        <tr>
          <td class="test_text">Does your store have an SSL certificate (shared/dedicated) installed and working?</td>
<?php
    if ($ssl_url) {
?>
          <td align="center" class="good">Yes</td>
<?php
    } else {
?>
          <td align="center" class="error">No</td>
<?php
    }
?>
        </tr>
        <tr><td class="divider" colspan="2"></td></tr>
        <tr>
          <td class="test_text">Is cURL installed?</td>
          <td align="center" class="<?php echo ($curl_exists ? 'good' : 'error'); ?>"><?php echo ($curl_exists ? 'Yes' : 'No'); ?></td>
        </tr>
        <tr><td class="divider" colspan="2"></td></tr>
<?php
    if ($curl_exists) {
?>
        <tr>
          <td class="test_text">Does cURL work? (Simple HTTP test)</td>
          <td align="center" class="<?php echo ($curl_works ? 'good' : 'error'); ?>"><?php echo ($curl_works ? 'Yes' : 'No'); ?></td>
        </tr>
<?php
      if ($curl_errors != '') {
?>
        <tr>
          <td class="test_text" colspan="2" style="color: #FF0000; padding-left: 20px"><?php echo $curl_errors; ?></td>
        </tr>
<?php
      }
?>
        <tr><td class="divider" colspan="2"></td></tr>
<?php
    }
?>
        <tr>
          <td class="test_text">API Certificate installed?</td>
          <td align="center" class="<?php echo ($cert_exists ? 'good' : 'error'); ?>"><?php echo ($cert_exists ? 'Yes' : 'No'); ?></td>
        </tr>
        <tr><td class="divider" colspan="2"></td></tr>
        <tr>
          <td class="test_text">API Username in place?</td>
          <td align="center" class="<?php echo ($user_exists ? 'good' : 'error'); ?>"><?php echo ($user_exists ? 'Yes' : 'No'); ?></td>
        </tr>
        <tr><td class="divider" colspan="2"></td></tr>
        <tr>
          <td class="test_text">API Password in place?</td>
          <td align="center" class="<?php echo ($pass_exists ? 'good' : 'error'); ?>"><?php echo ($pass_exists ? 'Yes' : 'No'); ?></td>
        </tr>
        <tr><td class="divider" colspan="2"></td></tr>
<?php
    for ($x = 0; $x < count($xml_documents); $x++) { 
?>
        <tr>
          <td class="test_text">XML Document "<?php echo $xml_documents[$x]; ?>" exists?</td>
          <td align="center" class="<?php echo ($xml_exists[$x] ? 'good' : 'error'); ?>"><?php echo ($xml_exists[$x] ? 'Yes' : 'No'); ?></td>
        </tr>
        <tr><td class="divider" colspan="2"></td></tr>
<?php
    }
    flush();
    if ($all_good) {
?>
        <tr>
          <td class="topHeader" valign="middle" colspan="2"><h1>Advanced Diagnostics</h1><span class="test_text"><?php echo MODULE_PAYMENT_PAYPAL_EC_SERVER; ?> server</span></td>
        </tr>
        <tr><td class="divider" colspan="2"></td></tr>
        <tr>
          <td class="test_text">Able to connect to PayPal through cURL?</td>
<?php
      $curl_success = false;
      $data = array();
      $data['PAYPAL_USERNAME'] = MODULE_PAYMENT_PAYPAL_API_USERNAME;
      $data['PAYPAL_PASSWORD'] = MODULE_PAYMENT_PAYPAL_API_PASSWORD;
      $data['PAYPAL_VERSION'] = '2.0';
      $data['PAYPAL_PAYMENT_ACTION'] = 'Authorization';
      $data['PAYPAL_MERCHANT_SESSION_ID'] = tep_session_id();
      $data['PAYPAL_IP_ADDRESS'] = $_SERVER['REMOTE_ADDR'];
      $data['PAYPAL_START_DATE'] = date('Y-m-d', mktime(0, 0, 0, date("m"), date("d")-1,  date("Y"))) . 'T00:00:00-0700';
      $data['PAYPAL_PAYER'] = STORE_OWNER_EMAIL_ADDRESS;
      $data['PAYPAL_AMOUNT'] = '1.00';
      $data['PAYPAL_CURRENCY'] = 'USD';

      $xml_file = DIR_WS_INCLUDES . 'ec_xml/diagnostics.xml';
      $fp = fopen($xml_file, "r");
      $xml_contents = fread($fp, filesize($xml_file));
      fclose($fp);

      foreach ($data as $k => $v) {
        $xml_contents = str_replace($k, $v, $xml_contents);
      }

      if (MODULE_PAYMENT_PAYPAL_EC_SERVER == 'Sandbox') {
        $paypal_url = "https://api.sandbox.paypal.com/2.0/";
      } else {
        $paypal_url = "https://api.paypal.com/2.0/";
      } 

      $ch = curl_init(); 

      if (trim(MODULE_PAYMENT_PAYPAL_EC_PROXY) != '') {
        curl_setopt($ch, CURLOPT_PROXYTYPE, CURLPROXY_HTTP);
        curl_setopt($ch, CURLOPT_PROXY, MODULE_PAYMENT_PAYPAL_EC_PROXY);
      }
      curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
      curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
      curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
      curl_setopt($ch, CURLOPT_TIMEOUT, 180);
      curl_setopt($ch, CURLOPT_SSLCERTTYPE, "PEM"); 
      curl_setopt($ch, CURLOPT_SSLCERT, MODULE_PAYMENT_PAYPAL_API_CERT_PATH);
      curl_setopt($ch, CURLOPT_URL, $paypal_url); 
      curl_setopt($ch, CURLOPT_POST, 1); 
      curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_contents); 

      $response = curl_exec($ch);
      $curl_connected = true;
      $curl_valid_response = true;
      $curl_error_message = '';

      if (@curl_errno($ch) != 0) {
        $curl_connected = false;
        $curl_error_message = 'Error received: ' . curl_errno($ch) . ': ' . curl_error($ch);
      } else {
        if (strpos($response, 'SOAP-ENV') === false) {
          $curl_valid_response = false;
        }
      }
      curl_close($ch);

      $response = ec_parse_xml($response);
?>
          <td align="center" class="<?php echo ($curl_connected ? 'good' : 'error'); ?>"><?php echo ($curl_connected ? 'Yes' : 'No'); ?></td>
        </tr>
<?php
      if ($curl_error_message != '') {
?>
        <tr>
          <td class="test_text" colspan="2" style="color: #FF0000; padding-left: 20px"><?php echo $curl_error_message; ?></td>
        </tr>
<?php
      }
?>
        <tr><td class="divider" colspan="2"></td></tr>
        <tr>
          <td class="test_text">Received a valid response?</td>
          <td align="center" class="<?php echo ($curl_valid_response ? 'good' : 'error'); ?>"><?php echo ($curl_valid_response ? 'Yes' : 'No'); ?></td>
        </tr>
        <tr><td class="divider" colspan="2"></td></tr>
<?php
      $failed_installation = false;
      if ($curl_valid_response) {
        $errors_received = false;
        if (is_array($response['TransactionSearchResponse'][0]['Errors'])) {
          $errors_received = true;
          $errors = $response['TransactionSearchResponse'][0]['Errors'];
          $error_return = '';

          for ($x = 0; $x < count($errors); $x++) {
            if ($error_return) $error_return .= '<br><br>';
            if (count($errors) > 1) {
              $error_return .= 'Error #' . ($x + 1) . ': ';
            }
            $error_return .= $errors[$x]['ShortMessage'] . ' (' . $errors[$x]['ErrorCode'] . ')<br>' . $errors[$x]['LongMessage'];
          }
        }
        if ($errors_received) $failed_installation = true;
?>
        <tr>
          <td class="test_text">Did PayPal respond without errors? (If not, errors are below)</td>
          <td align="center" class="<?php echo (!$errors_received ? 'good' : 'error'); ?>"><?php echo (!$errors_received ? 'Yes' : 'No'); ?></td>
        </tr>
<?php
        if ($errors_received) {
?>
        <tr>
          <td class="test_text" colspan="2" style="color: #FF0000; padding-left: 20px"><?php echo $error_return; ?></td>
        </tr>
<?php
        }
?>
        <tr><td class="divider" colspan="2"></td></tr>
        <tr>
          <td style="height: 20px"></td>
        </tr>
<?php
      }
      if ($failed_installation) {
?>
        <tr>
          <td colspan="2" class="topHeader" valign="middle" style="border: 2px solid #FF0000; padding: 20px"><center><h2><span style="color: #FF0000">Installation Incomplete!</span></h2></center><br><h1><span style="line-height: 20px">Review and resolve the errors above and run this script again.</span></h1></td>
        </tr>
<?php
      } else {
?>
        <tr>
          <td colspan="2" class="topHeader" valign="middle" style="border: 2px solid #009900; padding: 20px"><center><h2><span style="color: #009900">Success!</span></h2></center><br><h1><span style="line-height: 20px">Congratulations!  This contribution appears to be correctly installed on your store!<br><br>Please note that if you're still having problems with your installation, it is most likely because you didn't completely integrate all of the code.</span></h1></td>
        </tr>
        <tr>
          <td colspan="2 "class="test_test"><b><span class="error">WARNING!!</span>&nbsp;DO NOT keep this script in your host after use.<br>Keeping this diagnostics script in host could lead to possible security breaches!!</b></td>
        </tr>
<?php
      }
    } else {
?>
        <tr>
          <td style="height: 20px"></td>
        </tr>
        <tr>
          <td colspan="2" class="topHeader" valign="middle" style="border: 2px solid #FF0000; padding: 20px"><center><h2><span style="color: #FF0000">Test Stopped!</span></h2></center><br><h1><span style="line-height: 20px">Testing cannot be completed until the above errors are fixed.  After fixing the above errors, run this script again to complete the test.</span></h1></td>
        </tr>
<?php
    }
  }
?>
        <tr>
          <td style="height: 20px"></td>
        </tr>
      </table>
    </center>
  </body>
</html>
