<?php
/*
  $Id: paypal_ec.php,v 0.4.1.0 beta 2007/02/18 07:08:00 Alex Li Exp $

  Copyright (c) 2007 AlexStudio
  Released under the GNU General Public License
    
*/

  class paypal_ec {
    var $code, $title, $description, $enabled, $identifier;
    
    function paypal_ec() {
      global $order;

      $this->code = 'paypal_ec';
      $this->title = MODULE_PAYMENT_PAYPAL_EC_TEXT_TITLE;
      $this->description = MODULE_PAYMENT_PAYPAL_EC_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_PAYPAL_EC_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_PAYPAL_EC_STATUS == 'True') ? true : false);
      $this->identifier = 'PayPal EC IPN v0.1 beta';
      $this->show = MODULE_PAYMENT_PAYPAL_EC_TEXT_SELECTION;
      $this->order_status = 2;

      if (is_object($order)) $this->update_status();

      if (MODULE_PAYMENT_PAYPAL_EC_SERVER == 'Live') {
        $this->form_action_url = 'https://www.paypal.com/cgi-bin/webscr';
      } else {
        $this->form_action_url = 'https://www.sandbox.paypal.com/cgi-bin/webscr';
      }
    }  

// class methods
    function update_status() {
      global $order, $shipping;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_PAYPAL_EC_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_PAYPAL_EC_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      return array('id' => $this->code,
                   'module' => $this->show);
    }

    function ec_get_detail() {
      global $order, $customer_first_name, $customer_id, $languages_id;
      global $HTTP_GET_VARS, $_SESSION, $currencies, $currency;
        
      // First check if token exist
      if(!tep_session_is_registered('paypal_ec_token') || (isset($HTTP_GET_VARS['token']) && $_SESSION['paypal_ec_token'] != $HTTP_GET_VARS['token'])) {
        $this->ec_gen_error(MODULE_PAYMENT_PAYPAL_EC_TEXT_TOKEN_FAIL, true);
        $payment_error_return = 'payment_error=' . $this->code;
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }
      // Make sure the token is in the correct format
      if (!ereg("([C-E]{2})-([A-Z0-9]{17})", $_SESSION['paypal_ec_token'])){
        $this->ec_gen_error(MODULE_PAYMENT_PAYPAL_EC_TEXT_TOKEN_FAIL, true);
        $payment_error_return = 'payment_error=' . $this->code;
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }    
      $token_info = array('PAYPAL_TOKEN' => $_SESSION['paypal_ec_token']);

      $response_array = $this->ec_execute_transaction('getExpressCheckoutDetails', $token_info);
      $response = $response_array['response'];
      $data_xml = $response_array['xml'];

      if(!is_array($response) || ($response['GetExpressCheckoutDetailsResponse'][0]['Ack'] != 'Success' && $response['GetExpressCheckoutDetailsResponse'][0]['Ack'] != 'SuccessWithWarning')) {
        if (trim(MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL) != '') {
          $token_response = $this->ec_dump_array($response);
          $token_request = strtr($data_xml, '<>', '[]');
          tep_mail(STORE_OWNER, MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL, 'PayPal EC Error Dump', "In function: ec_get_detail()\r\nResponse from PayPal:\r\n\r\n" . $token_response . "\r\n\r\nFrom this request: (WARNING!!) DO NOT expose your API Username/Password to the public!!\r\n\r\n" . $token_request, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
        }
        $this->ec_gen_error(MODULE_PAYMENT_PAYPAL_EC_TEXT_GETDETAIL_ERROR . $this->return_transaction_errors($response['GetExpressCheckoutDetailsResponse'][0]['Errors']), true);
        $payment_error_return = 'payment_error=' . $this->code;
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }
// BOF Debug Email for developing
      if (trim(MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL) != '' && MODULE_PAYMENT_PAYPAL_EC_SUCCESS_EMAIL == 'True') {
        $token_response = $this->ec_dump_array($response);
        $token_request = strtr($data_xml, '<>', '[]');
        tep_mail(STORE_OWNER, MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL, 'PayPal EC Success Dump', "In function: ec_get_detail()\r\nResponse from PayPal:\r\n\r\n".$token_response."\r\n\r\nFrom this request: (WARNING!!) DO NOT expose your API Username/Password to the public!!\r\n\r\n" . $token_request, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
      }
// EOF Debug Email for developing

      $payer_info = $response['GetExpressCheckoutDetailsResponse'][0]['GetExpressCheckoutDetailsResponseDetails'][0]['PayerInfo'][0];
      if($order->content_type != 'virtual' && MODULE_PAYMENT_PAYPAL_EC_SKIP_ADDRESS == 'No' && MODULE_PAYMENT_PAYPAL_EC_REQ_VERIFIED == 'Yes' && strtolower($payer_info['PayerStatus']) != 'verified') {
        $this->ec_gen_error(MODULE_PAYMENT_PAYPAL_EC_TEXT_UNVERIFIED, true);
        $payment_error_return = 'payment_error=' . $this->code;
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }

      tep_session_register('paypal_ec_payer_id');
      $_SESSION['paypal_ec_payer_id'] = $payer_info['PayerID'];
      tep_session_register('paypal_ec_payer_info');
      $_SESSION['paypal_ec_payer_info'] = array( 'payer_id' => $payer_info['PayerID'],
                                                 'payer_email' => $payer_info['Payer'],
                                                 'payer_firstname' => $payer_info['PayerName'][0]['FirstName'],
                                                 'payer_lastname' => $payer_info['PayerName'][0]['LastName'],
                                                 'payer_business' => $payer_info['PayerBusiness'],
                                                 'payer_status' => $payer_info['PayerStatus'],
                                                 'payer_country' => $payer_info['PayerCountry'],
                                                 'ship_owner' => $payer_info['Address'][0]['AddressOwner'],
                                                 'ship_name' => $payer_info['Address'][0]['Name'],
                                                 'ship_street_1' => $payer_info['Address'][0]['Street1'],
                                                 'ship_street_2' => $payer_info['Address'][0]['Street2'],
                                                 'ship_city' => $payer_info['Address'][0]['CityName'],
                                                 'ship_state' => $payer_info['Address'][0]['StateOrProvince'],
                                                 'ship_postal_code' => $payer_info['Address'][0]['PostalCode'],
                                                 'ship_country' => $payer_info['Address'][0]['Country'],
                                                 'ship_country_name' => $payer_info['Address'][0]['CountryName'],
                                                 'ship_phone' => $payer_info['Address'][0]['Phone'],
                                                 'ship_phone' => $payer_info['ContactPhone'],
                                                 'ship_address_status' => $payer_info['Address'][0]['AddressStatus']);

      // Reject shipping to a different country (If not rejecting here, will be rejected by PayPal later with uncontrollable error message)
      if ($order->content_type != 'virtual' && MODULE_PAYMENT_PAYPAL_EC_SKIP_ADDRESS == 'No' && $payer_info['PayerCountry'] != $payer_info['Address'][0]['Country']) {
        $this->ec_gen_error('', true, true);
        $address_error = 'address_error=1';
        if (!tep_session_is_registered('paypal_ec_address_error')) tep_session_register('paypal_ec_address_error');
        $_SESSION['paypal_ec_address_error'] = array('title' => MODULE_PAYMENT_PAYPAL_EC_TEXT_ERROR_HEADING,
                                                     'message' => MODULE_PAYMENT_PAYPAL_EC_TEXT_COUNTRY_ERROR);
        tep_redirect(tep_href_link(FILENAME_EXPRESS_CHECKOUT_SHIPPING, $address_error, 'SSL'));
      }

      // Get the customer's country ID.
      $country_query = tep_db_query("SELECT countries_id, countries_name, countries_iso_code_2, countries_iso_code_3, address_format_id
                                     FROM ".TABLE_COUNTRIES."
                                     WHERE countries_iso_code_2 = '".$payer_info['Address'][0]['Country']."'
                                     OR countries_name = '".$payer_info['Address'][0]['CountryName']."'
                                     LIMIT 1");
      if (tep_db_num_rows($country_query) > 0) {
        $country = tep_db_fetch_array($country_query);
        $country_id = $country['countries_id'];
        $country_title = $country['countries_name'];
        $country_iso_2 = $country['countries_iso_code_2'];
        $country_iso_3 = $country['countries_iso_code_3'];
        $address_format_id = $country['address_format_id'];
      } else {
        $country_id = '';
        $country_title = $payer_info['Address'][0]['CountryName'];
        $country_iso_2 = $payer_info['Address'][0]['Country'];
        $country_iso_3 = '';
        $address_format_id = '2'; // 2 is the American format
      }

      // Get zone ID
      $zone_query = tep_db_query("SELECT zone_id FROM " . TABLE_ZONES . "
                                  WHERE zone_country_id = '".(int)$country_id."'
                                  AND ( zone_code = '".$payer_info['Address'][0]['StateOrProvince']."'
                                  OR zone_name = '".$payer_info['Address'][0]['StateOrProvince']."' ) LIMIT 1");
      if (tep_db_num_rows($zone_query) > 0) {
        $zone_array = tep_db_fetch_array($zone_query);
        $zone_id = $zone_array['zone_id'];
      } else $zone_id = '';

      // Separate delivery name
      $name_array = explode(" ", $payer_info['Address'][0]['Name'], 2);

      if ($order->content_type != 'virtual' && MODULE_PAYMENT_PAYPAL_EC_SKIP_ADDRESS == 'No') {
        // Check payer info
        if (!tep_not_null($payer_info['Address'][0]['Street1'])||!tep_not_null($payer_info['Address'][0]['CityName'])||!tep_not_null($payer_info['Address'][0]['Country'])) {
          $this->ec_gen_error('', true, true);
          $address_error = 'address_error=1';
          if (!tep_session_is_registered('paypal_ec_address_error')) tep_session_register('paypal_ec_address_error');
          $_SESSION['paypal_ec_address_error'] = array('title' => MODULE_PAYMENT_PAYPAL_EC_TEXT_ERROR_HEADING,
                                                       'message' => MODULE_PAYMENT_PAYPAL_EC_TEXT_GETDETAIL_ERROR);
          tep_redirect(tep_href_link(FILENAME_EXPRESS_CHECKOUT_SHIPPING, $address_error, 'SSL'));
        }

        if (MODULE_PAYMENT_PAYPAL_EC_EDIT_ADDRESS == 'Yes') { // Update shipping address only if allow editing at PayPal

          $order->delivery['firstname'] = tep_db_prepare_input($name_array[0]);
          $order->delivery['lastname'] = tep_db_prepare_input($name_array[1]);
          $order->delivery['company'] = tep_db_prepare_input($payer_info['PayerBusiness']);
          $order->delivery['street_address'] = tep_db_prepare_input($payer_info['Address'][0]['Street1']);
          $order->delivery['suburb'] = tep_db_prepare_input($payer_info['Address'][0]['Street2']);
          $order->delivery['city'] = tep_db_prepare_input($payer_info['Address'][0]['CityName']);
          $order->delivery['postcode'] = tep_db_prepare_input($payer_info['Address'][0]['PostalCode']);
          $order->delivery['state'] = tep_db_prepare_input($payer_info['Address'][0]['StateOrProvince']);
          $order->delivery['country']['id'] = $country_id;
          $order->delivery['country']['title'] = $country_title;
          $order->delivery['country']['iso_code_2'] = $country_iso_2;
          $order->delivery['country']['iso_code_3'] = $country_iso_3;
          $order->delivery['country_id'] = $country_id;
          $order->delivery['format_id'] = $address_format_id;

          // Set the delivery state field depending on what PayPal wants to see for that country
          if (tep_not_null($order->delivery['state'])) {
            $order->delivery['state'] = $this->ec_gen_state_code($order->delivery['state'], $order->delivery['country']['iso_code_2']);
          }

          // Check if the PayPal address is in address book, if not then add an address record
          $address_found = 0;
          $address_query = "select address_book_id, entry_firstname, entry_lastname, entry_state, entry_zone_id
                            from ".TABLE_ADDRESS_BOOK."
                            where customers_id = '".(int)$customer_id."'
                            and entry_street_address = '".$order->delivery['street_address']."'
                            and entry_suburb = '".$order->delivery['suburb']."'
                            and entry_postcode = '".$order->delivery['postcode']."'
                            and entry_city = '".$order->delivery['city']."'
                            and entry_country_id = '".(int)$country_id."'
                            and entry_zone_id = '".(int)$zone_id."'";
          $check_address_query = tep_db_query($address_query);
          $check_address_row = tep_db_num_rows($check_address_query);

          if ( $check_address_row == 1 ) { // Only 1 record found with the address sent back
            $check_address_array = tep_db_fetch_array($check_address_query);
            if ($zone_id != '' || strtoupper($check_address_array['entry_state']) == $order->delivery['state']) {
              $address_found = 1;
              $order->delivery['firstname'] = $check_address_array['entry_firstname'];
              $order->delivery['lastname'] = $check_address_array['entry_lastname'];
              if (!tep_session_is_registered('sendto')) tep_session_register('sendto');
              if ($_SESSION['sendto'] != $check_address_array['address_book_id']) {
                $_SESSION['sendto'] = $check_address_array['address_book_id'];
                if (tep_session_is_registered('shipping')) tep_session_unregister('shipping');
                $address_error = 'address_error=1';
                if (!tep_session_is_registered('paypal_ec_address_error')) tep_session_register('paypal_ec_address_error');
                $_SESSION['paypal_ec_address_error'] = array('title' => MODULE_PAYMENT_PAYPAL_EC_TEXT_ADDRESS_CHANGED_TITLE,
                                                             'message' => MODULE_PAYMENT_PAYPAL_EC_TEXT_ADDRESS_CHANGED_MESSAGE);
                tep_redirect(tep_href_link(FILENAME_EXPRESS_CHECKOUT_SHIPPING, $address_error, 'SSL'));
              }
            }
          } else if ( $check_address_row > 1 ) { // More than 1 record found with the address sent back (same address with different names)
            if (!tep_session_is_registered('sendto')) tep_session_register('sendto');
            while ($check_address_array = tep_db_fetch_array($check_address_query)) {
              $address_records[] = $check_address_array;
              if ($_SESSION['sendto'] == $check_address_array['address_book_id']) {
                // Customer selected address found, go with this one 
                $address_found = 1;
                $order->delivery['firstname'] = $check_address_array['entry_firstname'];
                $order->delivery['lastname'] = $check_address_array['entry_lastname'];
              }
            }
            if (!$address_found) { // couldn't decide which address record it is, try to go with one most likely (customer still can review and change it)
              $last_matched = 0;
              $record_found = 0;
              // pick one record which matches the most conditions
              for ($i = 0, $n = sizeof($address_records); $i < $n; $i++) {
                if ($zone_id != '' || strtoupper($address_records[$i]['entry_state']) == $order->delivery['state']) {
                  // address 100% matched
                  $last_matched = $i;
                  $address_found = 1;
                  if ($payer_info['Address'][0]['Name'] == $address_records[$i]['entry_firstname'] . ' ' . $address_records[$i]['entry_firstname']) {
                    // name matched
                    $_SESSION['sendto'] = $address_records[$i]['address_book_id'];
                    $record_found = 1;
                  }
                }
              }
              if ($address_found) {
                // Go with the last address record matched 100%
                if (!record_found) $_SESSION['sendto'] = $address_records[$last_matched]['address_book_id'];
                // Because we are not sure which record it is, we send customer to review and update the address
                if (tep_session_is_registered('shipping')) tep_session_unregister('shipping');
                $address_error = 'address_error=1';
                if (!tep_session_is_registered('paypal_ec_address_error')) tep_session_register('paypal_ec_address_error');
                $_SESSION['paypal_ec_address_error'] = array('title' => MODULE_PAYMENT_PAYPAL_EC_TEXT_ADDRESS_CHANGED_TITLE,
                                                             'message' => MODULE_PAYMENT_PAYPAL_EC_TEXT_ADDRESS_CHANGED_MESSAGE);
                tep_redirect(tep_href_link(FILENAME_EXPRESS_CHECKOUT_SHIPPING, $address_error, 'SSL'));
              }
            }
          }

          if (!$address_found) {
            // address not found, create a new record
            $sql_data_array = array('customers_id' => (int)$customer_id,
                                    'entry_company' => $order->delivery['company'],
                                    'entry_firstname' => $order->delivery['firstname'],
                                    'entry_lastname' => $order->delivery['lastname'],
                                    'entry_street_address' => $order->delivery['street_address'],
                                    'entry_suburb' => $order->delivery['suburb'],
                                    'entry_postcode' => $order->delivery['postcode'],
                                    'entry_city' => $order->delivery['city'],
                                    'entry_state' => $order->delivery['state'],
                                    'entry_country_id' => (int)$country_id,
                                    'entry_zone_id' => (int)$zone_id);

            tep_db_perform(TABLE_ADDRESS_BOOK, $sql_data_array);
            if (!tep_session_is_registered('sendto')) tep_session_register('sendto');
            $_SESSION['sendto'] = tep_db_insert_id();
            if (tep_session_is_registered('shipping')) tep_session_unregister('shipping');
            $address_error = 'address_error=1';
            if (!tep_session_is_registered('paypal_ec_address_error')) tep_session_register('paypal_ec_address_error');
            $_SESSION['paypal_ec_address_error'] = array('title' => MODULE_PAYMENT_PAYPAL_EC_TEXT_ADDRESS_CHANGED_TITLE,
                                                         'message' => MODULE_PAYMENT_PAYPAL_EC_TEXT_ADDRESS_CHANGED_MESSAGE);
            tep_redirect(tep_href_link(FILENAME_EXPRESS_CHECKOUT_SHIPPING, $address_error, 'SSL'));
          }
        }
      }
      if (tep_session_is_registered('paypal_ec_method') && $_SESSION['paypal_ec_method'] == 'button') {
        // If method is button and just got sent back from PayPal page, redirect to checkout shipping page to select shipping method.
        if (isset($HTTP_GET_VARS['token'])) tep_redirect(tep_href_link(FILENAME_EXPRESS_CHECKOUT_SHIPPING, '', 'SSL'));
      }
    }

    function ec_check_shipping_address() {
      global $_SESSION, $order;
        
      // Reject shipping to a different country (If not rejecting here, will be rejected by PayPal later with uncontrollable error message)
      if ($_SESSION['paypal_ec_payer_info']['payer_country'] != $order->delivery['country']['iso_code_2']) {
        $this->ec_gen_error('', true, true);
        $address_error = 'address_error=1';
        if (!tep_session_is_registered('paypal_ec_address_error')) tep_session_register('paypal_ec_address_error');
        $_SESSION['paypal_ec_address_error'] = array('title' => MODULE_PAYMENT_PAYPAL_EC_TEXT_ERROR_HEADING,
                                                     'message' => MODULE_PAYMENT_PAYPAL_EC_TEXT_COUNTRY_ERROR);
        tep_redirect(tep_href_link(FILENAME_EXPRESS_CHECKOUT_SHIPPING, $address_error, 'SSL'));
      }
    }

    function ec_gen_order_info() {
      global $_SESSION, $order, $currency, $currencies;

      $order_info = array();

      // Select currency, currently these 16 currencies are supported
      if (MODULE_PAYMENT_PAYPAL_EC_CURRENCY == 'Selected Currency') $currency_id = $currency;
      else $currency_id = substr(MODULE_PAYMENT_PAYPAL_EC_CURRENCY, 5);
      // currently 16 currencies 'officially' supported, but CZK HUF PLN got 3005 error from PayPal, so removed these 3.
      if (!in_array($currency_id, array('AUD', 'CAD', 'CHF', 'CZK', 'DKK', 'EUR', 'GBP', 'HKD', 'HUF', 'JPY', 'NOK', 'NZD', 'PLN', 'SEK', 'SGD', 'USD'))) $currency_id = 'USD';

      switch ($currency_id){
        case 'JPY':
        case 'HUF':
          $decimal = 0;
          break;
        default:
          $decimal = 2;
          break;
      }

      $su_total = round($order->info['subtotal'] * $currencies->get_value($currency_id), $decimal);
      $sh_total = round($order->info['shipping_cost'] * $currencies->get_value($currency_id), $decimal);
      $tx_item = round($this->ec_generate_PDI($currency_id, true) * $currencies->get_value($currency_id), $decimal);
      $tx_total = round($order->info['tax'] * $currencies->get_value($currency_id), $decimal);
      $ha_toatl = round(($order->info['total'] - $order->info['subtotal'] - $order->info['shipping_cost'] - $order->info['tax']) * $currencies->get_value($currency_id), $decimal);

      $order_info['PAYPAL_CURRENCY'] = $currency_id;
      $order_info['PAYPAL_ORDER_TOTAL'] = $su_total + $sh_total + $tx_total + $ha_toatl; //**** Use the sum of all items to avoid decimal rounds mismatch the total. 
      $order_info['PAYPAL_ORDER_DESCRIPTION'] = 'Order placed on ' . date("F j, Y, g:i a") . ' by ' . $order->customer['firstname'] . ' ' . $order->customer['lastname'] . ' (ID: ' . $_SESSION['customer_id'] . ')';
      $order_info['PAYPAL_CUSTOM'] = 'Phone: ' . $order->customer['telephone'] . ' -- Email: ' . $order->customer['email_address'];
      $order_info['PAYPAL_ITEM_TOTAL'] = $su_total;
      $order_info['PAYPAL_SHIPPING_TOTAL'] = $sh_total;
      $order_info['PAYPAL_HANDLING_TOTAL'] = $ha_toatl;
      $order_info['PAYPAL_TAX_TOTAL'] = $tx_total;
      $order_info['PAYPAL_NOTIFY_URL'] = tep_href_link('ext/modules/payment/paypal_ec/ipn.php', 'language=' . $_SESSION['language'], 'SSL', false, false);
      if ($order->content_type != 'virtual' && MODULE_PAYMENT_PAYPAL_EC_SKIP_ADDRESS == 'No') {
        $order_info['PAYPAL_SHIPPING_NAME'] = $order->delivery['firstname'] . ' ' . $order->delivery['lastname'];
        $order_info['PAYPAL_SHIPPING_ADDRESS1'] = $order->delivery['street_address'];
        $order_info['PAYPAL_SHIPPING_ADDRESS2'] = $order->delivery['suburb'];
        $order_info['PAYPAL_SHIPPING_CITY'] = $order->delivery['city'];
        $order_info['PAYPAL_SHIPPING_STATE'] = $order->delivery['state'];
        $order_info['PAYPAL_SHIPPING_ZIP'] = $order->delivery['postcode'];
        $order_info['PAYPAL_SHIPPING_COUNTRY'] = $order->delivery['country']['iso_code_2'];
      } else {
        $order_info['PAYPAL_SHIPPING_NAME'] = '';
        $order_info['PAYPAL_SHIPPING_ADDRESS1'] = '';
        $order_info['PAYPAL_SHIPPING_ADDRESS2'] = '';
        $order_info['PAYPAL_SHIPPING_CITY'] = '';
        $order_info['PAYPAL_SHIPPING_STATE'] = '';
        $order_info['PAYPAL_SHIPPING_ZIP'] = '';
        $order_info['PAYPAL_SHIPPING_COUNTRY'] = '';
      }
      $order_info['PAYPAL_TOKEN'] = $_SESSION['paypal_ec_token'];
      $order_info['PAYPAL_PAYER_ID'] = $_SESSION['paypal_ec_payer_id'];

      if (!tep_session_is_registered('paypal_ec_order_info')) tep_session_register('paypal_ec_order_info');
      $_SESSION['paypal_ec_order_info'] = $order_info;
    }
    
    function pre_confirmation_check() {
      global $order, $customer_first_name, $customer_id, $languages_id;
      global $HTTP_GET_VARS, $_SESSION, $PHP_SELF, $currencies, $currency;

      // If calling this payment module from checkout_confirmation.php then redirect to express_checkout.php
      if (!tep_not_null(strstr($PHP_SELF, FILENAME_EXPRESS_CHECKOUT))) {
        tep_redirect(tep_href_link(FILENAME_EXPRESS_CHECKOUT, $parameter, 'SSL'));
      }

      if (isset($HTTP_GET_VARS['token'])) { //<-- Customer just came back from PayPal
        if (!tep_session_is_registered('paypal_ec_returned')) tep_session_register('paypal_ec_returned');
        $_SESSION['paypal_ec_returned'] = true;
        $this->ec_get_detail();
        $this->ec_gen_order_info();
        $this->form_action_url = FILENAME_CHECKOUT_PROCESS;
      } else if (tep_session_is_registered('paypal_ec_order_info') || tep_session_is_registered('paypal_ec_payer_info')) {
        if ($order->content_type != 'virtual' && MODULE_PAYMENT_PAYPAL_EC_SKIP_ADDRESS == 'No') $this->ec_check_shipping_address();
        $this->ec_gen_order_info();
        $this->form_action_url = FILENAME_CHECKOUT_PROCESS;
      } else if (tep_session_is_registered('paypal_ec_token') && tep_session_is_registered('paypal_ec_returned')) {
        $this->ec_get_detail();
        $this->ec_gen_order_info();
        $this->form_action_url = FILENAME_CHECKOUT_PROCESS;
      } else {
//****** Prepare new token initiation *****************************//
        if (tep_session_is_registered('paypal_ec_method')) {
          $ec_method = $_SESSION['paypal_ec_method'];
          $this->ec_gen_error('', true, true); //<-- Destroy existing token
          tep_session_register('paypal_ec_method');
          $_SESSION['paypal_ec_method'] = $ec_method;
        } else $this->ec_gen_error('', true, true); //<-- Destroy existing token
        $order_info = array();

        //Find out the user's language so that if PayPal supports it, it'll be the language used on PayPal's site.
        $lang_query = tep_db_query("SELECT CODE FROM " . TABLE_LANGUAGES . " WHERE languages_id = '".$languages_id."' LIMIT 1");

        if(tep_db_num_rows($lang_query)) {
          $lang_id = tep_db_fetch_array($lang_query);
          //Only 6 country codes are valid, so default to the good ol' US of A if they're from Krazakalakastan
          //AU can be added if needed.
          switch ($lang_id['code']) {
            case 'de':
              $lang_code = 'DE';
              break;
            case 'fr':
              $lang_code = 'FR';
              break;
            case 'it':
              $lang_code = 'IT';
              break;
            case 'ja':
              $lang_code = 'JP';
              break;
            default:
              $lang_code = 'US';
              break;
          }
        } else {
          $lang_code = 'US';
        }      
        // Select currency, currently these 16 currencies are supported
        if (MODULE_PAYMENT_PAYPAL_EC_CURRENCY == 'Selected Currency') $currency_id = $currency;
        else $currency_id = substr(MODULE_PAYMENT_PAYPAL_EC_CURRENCY, 5);
        if (!in_array($currency_id, array('AUD', 'CAD', 'CHF', 'CZK', 'DKK', 'EUR', 'GBP', 'HKD', 'HUF', 'JPY', 'NOK', 'NZD', 'PLN', 'SEK', 'SGD', 'USD'))) $currency_id = 'USD';
        switch ($currency_id){
          case 'JPY':
          case 'HUF':
            $decimal = 0;
            break;
          default:
            $decimal = 2;
            break;
        }
        $su_total = round($order->info['subtotal'] * $currencies->get_value($currency_id), $decimal);
        $sh_total = round($order->info['shipping_cost'] * $currencies->get_value($currency_id), $decimal);
        $tx_total = round($order->info['tax'] * $currencies->get_value($currency_id), $decimal);
        $ha_toatl = round(($order->info['total'] - $order->info['subtotal'] - $order->info['shipping_cost'] - $order->info['tax']) * $currencies->get_value($currency_id), $decimal);

        $order_info['PAYPAL_ORDER_TOTAL'] = $su_total + $sh_total + $tx_total + $ha_toatl; //**** Use the sum of all items to avoid decimal rounds mismatch the total. 
        $order_info['PAYPAL_CURRENCY'] = $currency_id;
        if (trim(MODULE_PAYMENT_PAYPAL_EC_PAGE_STYLE) != '') {
          $order_info['PAYPAL_PAGE_STYLE'] = MODULE_PAYMENT_PAYPAL_EC_PAGE_STYLE;
        } else {
          $order_info['PAYPAL_PAGE_STYLE'] = 'PayPal';
        }
        $order_info['PAYPAL_RETURN_URL'] = tep_href_link(FILENAME_EXPRESS_CHECKOUT, '', 'SSL');
        if (MODULE_PAYMENT_PAYPAL_EC_BUTTON_INSTALLED == 'Yes') {
          $address_error = 'address_error=0';
          if (!tep_session_is_registered('paypal_ec_address_error')) tep_session_register('paypal_ec_address_error');
          $_SESSION['paypal_ec_address_error'] = array('title' => MODULE_PAYMENT_PAYPAL_EC_TEXT_ERROR_HEADING,
                                                       'message' => MODULE_PAYMENT_PAYPAL_EC_TEXT_CANCELLED);
          $order_info['PAYPAL_CANCEL_URL'] = tep_href_link(FILENAME_EXPRESS_CHECKOUT_SHIPPING, $address_error, 'SSL', false, false);
        } else {
          $this->ec_gen_error(MODULE_PAYMENT_PAYPAL_EC_TEXT_CANCELLED);
          $payment_error_return = 'payment_error=' . $this->code;
          $order_info['PAYPAL_CANCEL_URL'] = tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', false, false);
        }
      
        if(MODULE_PAYMENT_PAYPAL_EC_CONFIRM_ADDRESS == 'Yes') {
          $order_info['PAYPAL_REQUIRE_CONFIRM_SHIPPING'] = '1';
        } else {
          $order_info['PAYPAL_REQUIRE_CONFIRM_SHIPPING'] = '0';
        }

        $order_info['PAYPAL_LOCALE_CODE'] = $lang_code;
        if (MODULE_PAYMENT_PAYPAL_EC_EDIT_ADDRESS == 'Yes') $order_info['PAYPAL_ADDRESS_OVERRIDE'] = '0';
        else $order_info['PAYPAL_ADDRESS_OVERRIDE'] = '1';
        if ($order->content_type == 'virtual' || MODULE_PAYMENT_PAYPAL_EC_SKIP_ADDRESS == 'Yes') {
          $order_info['PAYPAL_NO_SHIPPING'] = '1';
          $order_info['PAYPAL_ADDRESS_OVERRIDE'] = '0';
          $order_info['PAYPAL_NAME'] = $order->billing['firstname'] . ' ' . $order->billing['lastname'];
          $order_info['PAYPAL_ADDRESS1'] = $order->billing['street_address'];
          $order_info['PAYPAL_ADDRESS2'] = $order->billing['suburb'];
          $order_info['PAYPAL_CITY'] = $order->billing['city'];
          if (tep_not_null($order->billing['state'])) {
            $order_info['PAYPAL_STATE'] = $this->ec_gen_state_code($order->billing['state'], $order->billing['country']['iso_code_2']);
          } else $order_info['PAYPAL_STATE'] = '';
          $order_info['PAYPAL_ZIP'] = $order->billing['postcode'];
          $order_info['PAYPAL_COUNTRY'] = $order->billing['country']['iso_code_2'];
          $order_info['PAYPAL_PHONE'] = $order->customer['telephone'];
          $order_info['PAYPAL_EMAIL'] = $order->customer['email_address'];
        } else {
          $order_info['PAYPAL_NO_SHIPPING'] = '0';
          $order_info['PAYPAL_NAME'] = $order->delivery['firstname'] . ' ' . $order->delivery['lastname'];
          $order_info['PAYPAL_ADDRESS1'] = $order->delivery['street_address'];
          $order_info['PAYPAL_ADDRESS2'] = $order->delivery['suburb'];
          $order_info['PAYPAL_CITY'] = $order->delivery['city'];
          if (tep_not_null($order->delivery['state'])) {
            $order_info['PAYPAL_STATE'] = $this->ec_gen_state_code($order->delivery['state'], $order->delivery['country']['iso_code_2']);
          } else $order_info['PAYPAL_STATE'] = '';
          $order_info['PAYPAL_ZIP'] = $order->delivery['postcode'];
          $order_info['PAYPAL_COUNTRY'] = $order->delivery['country']['iso_code_2'];
          $order_info['PAYPAL_PHONE'] = $order->customer['telephone'];
          $order_info['PAYPAL_EMAIL'] = $order->customer['email_address'];
        }

        // EC API token initiation
        $response_array = $this->ec_execute_transaction('setExpressCheckout', $order_info);
        $response = $response_array['response'];
        $data_xml = $response_array['xml'];

        // Check token response
        if(!is_array($response) || ($response['SetExpressCheckoutResponse'][0]['Ack'] != 'Success' && $response['SetExpressCheckoutResponse'][0]['Ack'] != 'SuccessWithWarning')) {
          if ($response['SetExpressCheckoutResponse'][0]['Errors'][0]['ErrorCode'] != '') {
            switch ($response['SetExpressCheckoutResponse'][0]['Errors'][0]['ErrorCode']) {
              case '10727':
              case '10728':
              case '10729':
              case '10730':
              case '10731':
              case '10736':
                $this->ec_gen_error('', true, true);
                if (!tep_session_is_registered('paypal_ec_address_error')) tep_session_register('paypal_ec_address_error');
                $_SESSION['paypal_ec_address_error'] = array('title' => 'Error! - ' . $response['SetExpressCheckoutResponse'][0]['Errors'][0]['ShortMessage'],
                                                             'message' => $response['SetExpressCheckoutResponse'][0]['Errors'][0]['LongMessage']);
                $address_error = 'address_error=' . $response['SetExpressCheckoutResponse'][0]['Errors'][0]['ErrorCode'];
                tep_redirect(tep_href_link(FILENAME_EXPRESS_CHECKOUT_SHIPPING, $address_error, 'SSL', true, false));
                break;
              default:
                if (trim(MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL) != '') {
                  $token_response = $this->ec_dump_array($response);
                  $token_request = strtr($data_xml, '<>', '[]');
                  tep_mail(STORE_OWNER, MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL, 'PayPal EC Error Dump', "In function: pre_confirmation_check()\r\nResponse from PayPal:\r\n\r\n" . $token_response . "\r\n\r\nFrom this request: (WARNING!!) DO NOT expose your API Username/Password to the public!!\r\n\r\n" . $token_request, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
                }
                $this->ec_gen_error(MODULE_PAYMENT_PAYPAL_EC_TEXT_SETEC_ERROR . $this->return_transaction_errors($response['SetExpressCheckoutResponse'][0]['Errors']), true);
                $payment_error_return = 'payment_error=' . $this->code;
                tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
                break;
            }
          } else {
            if (trim(MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL) != '') {
              $token_response = $this->ec_dump_array($response);
              $token_request = strtr($data_xml, '<>', '[]');
              tep_mail(STORE_OWNER, MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL, 'PayPal EC Error Dump', "In function: pre_confirmation_check()\r\nResponse from PayPal:\r\n\r\n" . $token_response . "\r\n\r\nFrom this request: (WARNING!!) DO NOT expose your API Username/Password to the public!!\r\n\r\n" . $token_request, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
            }
            $this->ec_gen_error(MODULE_PAYMENT_PAYPAL_EC_TEXT_SETEC_ERROR . $this->return_transaction_errors($response['SetExpressCheckoutResponse'][0]['Errors']), true);
            $payment_error_return = 'payment_error=' . $this->code;
            tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
          }
        } else {
          if (!tep_session_is_registered('paypal_ec_token')) tep_session_register('paypal_ec_token');
          $_SESSION['paypal_ec_token'] = $response['SetExpressCheckoutResponse'][0]['Token'];
// BOF Debug Email for developing
          if (trim(MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL) != '' && MODULE_PAYMENT_PAYPAL_EC_SUCCESS_EMAIL == 'True') {
            $token_response = $this->ec_dump_array($response);
            $token_request = strtr($data_xml, '<>', '[]');
            tep_mail(STORE_OWNER, MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL, 'PayPal EC Seccuss Dump', "In function: pre_confirmation_check()\r\nResponse from PayPal:\r\n\r\n".$token_response."\r\n\r\nFrom this request: (WARNING!!) DO NOT expose your API Username/Password to the public!!\r\n\r\n" . $token_request, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
          }
// EOF Debug Email for developing
          if (MODULE_PAYMENT_PAYPAL_EC_SKIP_CONFIRMATION == 'Yes') tep_redirect($this->form_action_url . "?cmd=_express-checkout&token=" . $_SESSION['paypal_ec_token']);
        }
      }
    }

    function confirmation() {
      global $_SESSION;

      if (!tep_session_is_registered('paypal_ec_method')) {
        tep_session_register('paypal_ec_method');
        $_SESSION['paypal_ec_method'] = 'selected';
      }
      $confirmation = array('title' => MODULE_PAYMENT_PAYPAL_EC_TEXT_TITLE ."<br>". MODULE_PAYMENT_PAYPAL_EC_TEXT_SELECTION, 'fields' => array());
      return $confirmation;
    }
    
    function process_button() {
      global $_SESSION;
      if ( tep_session_is_registered('paypal_ec_token') ){  //<-- Prepare the button to send customer to PayPal
        $parameters = array();
        $parameters['cmd'] = '_express-checkout';
        $parameters['token'] = $_SESSION['paypal_ec_token'];
        $parameters['useraction'] = 'continue';
        while (list($key, $value) = each($parameters)) {
          echo tep_draw_hidden_field($key, $value);
        }
      }
      return '';
    }

    function express_checkout() {
      global $_SESSION;

      if (tep_session_is_registered('paypal_ec_token')) tep_session_unregister('paypal_ec_token');
      if (!tep_session_is_registered('paypal_ec_method')) tep_session_register('paypal_ec_method');
      $_SESSION['paypal_ec_method'] = 'button';
      $this->pre_confirmation_check();
      if (tep_session_is_registered('paypal_ec_token') && tep_not_null($_SESSION['paypal_ec_token']) && !tep_session_is_registered('paypal_ec_order_info')) {
        tep_redirect($this->form_action_url . "?cmd=_express-checkout&token=" . $_SESSION['paypal_ec_token']);
      } else {
        if (tep_session_is_registered('paypal_ec_method')) tep_session_unregister('paypal_ec_method');
        return false;
      }
    }
    
    function return_transaction_errors($errors) {
      //Paypal will sometimes send back more than one error message, so we must loop through them if necessary
      $error_return = '';
      
      if (is_array($errors)) {
        for ($x = 0; $x < count($errors); $x++) {
          if ($error_return) $error_return .= '<br><br>';
          if (count($errors) > 1) {
            $error_return .= 'Error #' . ($x + 1) . ': ';
          }
          $error_return .= $errors[$x]['ShortMessage'] . ' (' . $errors[$x]['ErrorCode'] . ')<br>' . $errors[$x]['LongMessage'];
        }
      }
      
      return $error_return;
    }

    function ec_gen_error($error_msg = '', $kill_sess_vars = false, $kill_error = false) {
      global $_SESSION;

      if ($kill_sess_vars) {
        if (tep_session_is_registered('paypal_ec_method')) tep_session_unregister('paypal_ec_method');
        if (tep_session_is_registered('paypal_ec_token')) tep_session_unregister('paypal_ec_token');
        if (tep_session_is_registered('paypal_ec_returned')) tep_session_unregister('paypal_ec_returned');
        if (tep_session_is_registered('paypal_ec_payer_id')) tep_session_unregister('paypal_ec_payer_id');
        if (tep_session_is_registered('paypal_ec_payer_info')) tep_session_unregister('paypal_ec_payer_info');
        if (tep_session_is_registered('paypal_ec_order_info')) tep_session_unregister('paypal_ec_order_info');
      }
      if (!$kill_error) {
        if (!tep_session_is_registered('paypal_ec_error')) tep_session_register('paypal_ec_error');
        $_SESSION['paypal_ec_error'] = $error_msg;
      } else {
        if (tep_session_is_registered('paypal_ec_error')) tep_session_unregister('paypal_ec_error');
      }
    }

    function ec_execute_transaction($type, $data) {
      // Make sure cURL exists
      if (!function_exists('curl_init')) {
        $this->ec_gen_error(MODULE_PAYMENT_PAYPAL_EC_TEXT_CURL_NOT_INSTALLED, true);
        $payment_error_return = 'payment_error=' . $this->code;
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }
      
      //Make sure the certificate exists
      if (!file_exists(MODULE_PAYMENT_PAYPAL_API_CERT_PATH)) {
        $this->ec_gen_error(MODULE_PAYMENT_PAYPAL_API_CERT_NOT_INSTALLED, true);
        $payment_error_return = 'payment_error=' . $this->code;
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }
      // Add some common variables to the $data array
      $data['PAYPAL_USERNAME'] = MODULE_PAYMENT_PAYPAL_API_USERNAME;
      $data['PAYPAL_PASSWORD'] = MODULE_PAYMENT_PAYPAL_API_PASSWORD;
      $data['PAYPAL_VERSION'] = '2.0';
      $data['PAYPAL_PAYMENT_ACTION'] = 'Sale';
      $data['PAYPAL_MERCHANT_SESSION_ID'] = tep_session_id();
      $data['PAYPAL_IP_ADDRESS'] = $_SERVER['REMOTE_ADDR'];

      if (MODULE_PAYMENT_PAYPAL_EC_SERVER == 'Live') {
        $paypal_url = "https://api.paypal.com/2.0/"; 
      } else { 
        $paypal_url = "https://api.sandbox.paypal.com/2.0/"; 
      } 
      // Make sure the XML file exists
      if (file_exists(DIR_FS_CATALOG . DIR_WS_INCLUDES . 'ec_xml/' . $type . '.xml')) {
        // Suck in XML framework
        $xml_file = DIR_FS_CATALOG . DIR_WS_INCLUDES . 'ec_xml/' . $type . '.xml';
        $fp = fopen($xml_file, "r");
        $xml_contents = fread($fp, filesize($xml_file));
        fclose($fp);

        // Now, replace all of the placeholders with real data
        foreach ($data as $k => $v) {
          $xml_contents = str_replace($k, $v, $xml_contents);
        }

        // Initialize curl
        $ch = curl_init(); 

        // For the poor souls on GoDaddy and the like, set the connection to go through their proxy
        if (trim(MODULE_PAYMENT_PAYPAL_EC_PROXY) != '') {
          curl_setopt($ch, CURLOPT_PROXYTYPE, CURLPROXY_HTTP);
          curl_setopt($ch, CURLOPT_PROXY, MODULE_PAYMENT_PAYPAL_EC_PROXY);
        }
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 180);
        curl_setopt($ch, CURLOPT_SSLCERTTYPE, "PEM"); 
        curl_setopt($ch, CURLOPT_SSLCERT, MODULE_PAYMENT_PAYPAL_API_CERT_PATH);
        curl_setopt($ch, CURLOPT_URL, $paypal_url);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $xml_contents);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);

        $response = curl_exec($ch);
        curl_close($ch);

        // Simple check to make sure that this is a valid response
        if (strpos($response, 'SOAP-ENV') === false) {
          $response = false;
        }
        if ($response) {
          // Convert the XML into an easy-to-use associative array
          $response = $this->ec_parse_xml($response);       
        }
        return array('response' => $response,
                     'xml' => $xml_contents);
      } else {
        // Uh oh, someone has missing XML files!
        $this->ec_gen_error(MODULE_PAYMENT_PAYPAL_EC_TEXT_MISSING_XML, true);
        $payment_error_return = 'payment_error=' . $this->code;
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }
    }

    //Breaks the XML response into an associative array
    function ec_parse_xml($text) {
      $reg_exp = '/<(\w+)[^>]*>(.*?)<\/\\1>/s';
      preg_match_all($reg_exp, $text, $match);
      foreach ($match[1] as $key=>$val) {
        if ( preg_match($reg_exp, $match[2][$key]) ) {
            $array[$val][] = $this->ec_parse_xml($match[2][$key]);
        } else {
            $array[$val] = $match[2][$key];
        }
      }
      return $array;
    } 

    //Dump the response array into an string
    function ec_dump_array($array, $indent="", $eoln = "\n") {
      $string = "";
      if (!is_array($array) && !is_object($array)) return $array;
      $_indent = $indent;
      foreach ($array as $key=>$value) {
        if (is_array($value)) {
          $string .= $indent . "[".$key."]" . $eoln;
          if (trim($indent) == "") $indent .= "    ";
          else $indent .= $indent;
          $value_array = $this->ec_dump_array($value, $indent, $eoln);
          $string .= rtrim($value_array) . $eoln . $eoln;
        } else {
          $string .= $indent . "[".$key."] = ".(trim($value) == "" ? "N/A" : $value) . $eoln;
        }
        $indent = $_indent;
      }
      $string = strtr($string, array_flip(get_html_translation_table(HTML_SPECIALCHARS)));
      return strtr($string, array_flip(array("'"=>"&apos;")));
    }

    //This function generates the PaymentDetailsItem type for doExpressCheckout
    function ec_generate_PDI($currency_id, $item_tax_only = false) {
      global $order, $currencies, $languages_id;
      
      $output = '';
      $tax_item_total = 0;
      
      if (is_array($order->products)) {
        for ($i=0, $n=sizeof($order->products); $i<$n; $i++) {
          $tax_value = ($order->products[$i]['tax'] / 100) * $order->products[$i]['final_price'];
          $item_name = $order->products[$i]['name'];
          if (isset($order->products[$i]['attributes'])) {
            for ($j=0, $n2=sizeof($order->products[$i]['attributes']); $j<$n2; $j++) {
              if (DOWNLOAD_ENABLED == 'true') {
                $attributes_query = "select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix, pad.products_attributes_maxdays, pad.products_attributes_maxcount , pad.products_attributes_filename
                                     from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa
                                     left join " . TABLE_PRODUCTS_ATTRIBUTES_DOWNLOAD . " pad
                                     on pa.products_attributes_id=pad.products_attributes_id
                                     where pa.products_id = '" . $order->products[$i]['id'] . "'
                                     and pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "'
                                     and pa.options_id = popt.products_options_id
                                     and pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "'
                                     and pa.options_values_id = poval.products_options_values_id
                                     and popt.language_id = '" . $languages_id . "'
                                     and poval.language_id = '" . $languages_id . "'";
                $attributes = tep_db_query($attributes_query);
              } else {
                $attributes = tep_db_query("select popt.products_options_name, poval.products_options_values_name, pa.options_values_price, pa.price_prefix from " . TABLE_PRODUCTS_OPTIONS . " popt, " . TABLE_PRODUCTS_OPTIONS_VALUES . " poval, " . TABLE_PRODUCTS_ATTRIBUTES . " pa where pa.products_id = '" . $order->products[$i]['id'] . "' and pa.options_id = '" . $order->products[$i]['attributes'][$j]['option_id'] . "' and pa.options_id = popt.products_options_id and pa.options_values_id = '" . $order->products[$i]['attributes'][$j]['value_id'] . "' and pa.options_values_id = poval.products_options_values_id and popt.language_id = '" . $languages_id . "' and poval.language_id = '" . $languages_id . "'");
              }
              $attributes_values = tep_db_fetch_array($attributes);

              $item_name .= '-' . $attributes_values['products_options_name'];
              $item_name .= '-' . $attributes_values['products_options_values_name'];
            }
          }
          switch ($currency_id){
            case 'JPY':
            case 'HUF':
              $decimal = 0;
              break;
            default:
              $decimal = 2;
              break;
          }
          $output .= '<PaymentDetailsItem>';
          $output .= '<Name>' . $this->ec_xml_safe($item_name) . '</Name>';
          $output .= '<Number>' . $order->products[$i]['id'] . ' (' . $this->ec_xml_safe($order->products[$i]['model']) . ')</Number>';
          $output .= '<Amount currencyID="' . $currency_id . '">' . round($order->products[$i]['final_price'] * $currencies->get_value($currency_id), $decimal) . '</Amount>';
          $output .= '<Quantity>' . $order->products[$i]['qty'] . '</Quantity>';
          $output .= '<Tax currencyID="' . $currency_id . '">' . round($tax_value * $currencies->get_value($currency_id), $decimal) . '</Tax>';
          $output .= '</PaymentDetailsItem>';
          $tax_item_total += round($tax_value * $currencies->get_value($currency_id), $decimal);
        }
      }
      if ($item_tax_only) return $tax_item_total;
      else return $output;
    }

    function ec_xml_safe($str) {
      //The 5 evil characters in XML
      $str = str_replace('<', '&lt;', $str);
      $str = str_replace('>', '&gt;', $str);
      $str = str_replace('&', '&amp;', $str);
      $str = str_replace("'", '&apos;', $str);
      $str = str_replace('"', '&quot;', $str);

      return $str;
    }

    function ec_gen_state_code($state, $country_code_2) {
      if (tep_not_null($state)) {
        // Get country id first
        $country_query = tep_db_query("SELECT countries_id FROM ".TABLE_COUNTRIES." WHERE countries_iso_code_2 = '".$country_code_2."'");
        if (tep_db_num_rows($country_query) > 0) {
          $country_array = tep_db_fetch_array($country_query);
          $country_id = $country_array['countries_id'];
        } else {
          $country_id = '';
        }
        // Set state code depends on the country iso code 2
        switch ($country_code_2) {
          case 'US':
          case 'CA':
            $state_query = tep_db_query("SELECT zone_code FROM " . TABLE_ZONES . "
                                         WHERE ( zone_name = '".$state."' OR zone_code = '".$state."' )
                                         AND zone_country_id = '".(int)$country_id."'");
            if (tep_db_num_rows($state_query) > 0) {
              $state_array = tep_db_fetch_array($state_query);
              $state_code = $state_array['zone_code'];
            } else {
              $address_error = 'address_error=1';
              if (!tep_session_is_registered('paypal_ec_address_error')) tep_session_register('paypal_ec_address_error');
              $_SESSION['paypal_ec_address_error'] = array('title' => MODULE_PAYMENT_PAYPAL_EC_TEXT_ERROR_HEADING,
                                                           'message' => MODULE_PAYMENT_PAYPAL_EC_TEXT_STATE_ERROR);
              tep_redirect(tep_href_link(FILENAME_EXPRESS_CHECKOUT_SHIPPING, $address_error, 'SSL'));
            }
            break;
          case 'AT':
          case 'BE':
          case 'FR':
          case 'DE':
          case 'CH':
            $state_code = '';
            break;
          default:
            $state_code = $state;
            break;
        }
      } else $state_code = '';
      return $state_code;
    }
	
    function before_process() {
      global $_SESSION, $order;

      // Last time checking before sending the payment request
      if (!tep_session_is_registered('paypal_ec_token') || !tep_session_is_registered('paypal_ec_order_info')) {
        $this->ec_gen_error(MODULE_PAYMENT_PAYPAL_EC_TEXT_TOKEN_FAIL, true);
        $payment_error_return = 'payment_error=' . $this->code;
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }
      $order_info = $_SESSION['paypal_ec_order_info'];
      $order_info['PAYMENT_DETAILS_ITEM'] = $this->ec_generate_PDI($order_info['PAYPAL_CURRENCY']);
      // Extra checking for the state code, it could have been altered at checkout shipping page if the methood is button.
      if (tep_not_null($order_info['PAYPAL_SHIPPING_STATE']) && $order->content_type != 'virtual' && MODULE_PAYMENT_PAYPAL_EC_SKIP_ADDRESS == 'No') {
        $order_info['PAYPAL_SHIPPING_STATE'] = $this->ec_gen_state_code($order_info['PAYPAL_SHIPPING_STATE'], $order_info['PAYPAL_SHIPPING_COUNTRY']);
      }
      
      $response_array = $this->ec_execute_transaction('doExpressCheckout', $order_info);
      $response = $response_array['response'];
      $data_xml = $response_array['xml'];

      //Response processing
      if(!is_array($response) || ($response['DoExpressCheckoutPaymentResponse'][0]['Ack'] != 'Success' && $response['DoExpressCheckoutPaymentResponse'][0]['Ack'] != 'SuccessWithWarning')) {
        if (trim(MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL) != '') {
          //Send the store owner a complete dump of the transaction
          //$order_info['PAYMENT_DETAILS_ITEM'] = $this->ec_parse_xml($order_info['PAYMENT_DETAILS_ITEM']);
          $final_response = $this->ec_dump_array($response);
          $final_request = strtr($data_xml, '<>', '[]');
          tep_mail(STORE_OWNER, MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL, 'PayPal EC Error Dump', "In function: before_process()\r\nResponse from PayPal:\r\n\r\n".$final_response."\r\n\r\nFrom this request: (WARNING!!) DO NOT expose your API Username/Password to the public!!\r\n\r\n" . $final_request, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
        }

        if ($response['DoExpressCheckoutPaymentResponse'][0]['Errors'][0]['ErrorCode'] == '') {
          $this->ec_gen_error(MODULE_PAYMENT_PAYPAL_EC_TEXT_DOEC_NO_RESPONSE_ERROR, true);
          $payment_error_return = 'payment_error=' . $this->code;
          tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
        } else {
          $this->ec_gen_error(MODULE_PAYMENT_PAYPAL_EC_TEXT_DOEC_RESPONSE_ERROR . $this->return_transaction_errors($response['DoExpressCheckoutPaymentResponse'][0]['Errors']), true);
          $payment_error_return = 'payment_error=' . $this->code;
          tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
        }
      } else {
// BOF Debug Email for developing
        if (trim(MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL) != '' && MODULE_PAYMENT_PAYPAL_EC_SUCCESS_EMAIL == 'True') {
          $order_info['PAYMENT_DETAILS_ITEM'] = $this->ec_parse_xml($order_info['PAYMENT_DETAILS_ITEM']);
          $final_response = $this->ec_dump_array($response);
          $final_request = strtr($data_xml, '<>', '[]');
          tep_mail(STORE_OWNER, MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL, 'PayPal EC Success Dump', "In function: before_process()\r\nResponse from PayPal:\r\n\r\n".$final_response."\r\n\r\nFrom this request: (WARNING!!) DO NOT expose your API Username/Password to the public!!\r\n\r\n" . $final_request, STORE_OWNER, STORE_OWNER_EMAIL_ADDRESS);
        }
// EOF Debug Email for developing
        $details = $response['DoExpressCheckoutPaymentResponse'][0]['DoExpressCheckoutPaymentResponseDetails'][0]['PaymentInfo'][0];
        $this->payment_type = 'PayPal Express Checkout IPN';
        $this->trans_id = $details['TransactionID'];
        $this->payment_status = trim($details['PaymentStatus']);
        $this->avs = 'N/A';
        $this->cvv2 = 'N/A';

        if ($this->payment_status == 'Pending') {
          $this->pending_reason = $details['PendingReason'];
          $this->payment_status .= ' (' . $this->pending_reason . ')';
          $order->info['order_status'] = 1;
        } else if ($this->payment_status == 'Completed') {
          $order->info['order_status'] = MODULE_PAYMENT_PAYPAL_EC_ORDER_STATUS_ID;
        }
      }
    }

    function after_process() {
      global $insert_id;

      tep_db_query("update " . TABLE_ORDERS_STATUS_HISTORY . " set comments = concat(if(trim(comments) != '', concat(trim(comments), '\n\n'), ''), 'Transaction ID: " . $this->trans_id . "\nPayment Type: " . $this->payment_type . "\nPayment Status: " . $this->payment_status . "') where orders_id = " . $insert_id);

      if (tep_session_is_registered('paypal_ec_token')) {
        $this->ec_gen_error('', true, true); //<-- Destroy existing token
        if (tep_session_is_registered('paypal_ec_address_error')) tep_session_unregister('paypal_ec_address_error');
      }
    }

    function get_error() {
      global $language;
      require(DIR_WS_LANGUAGES . $language . '/modules/payment/' . FILENAME_PAYPAL_EC);

      $error ='';

      if (tep_session_is_registered('paypal_ec_error') && $_SESSION['paypal_ec_error'] != '') $error = $_SESSION['paypal_ec_error'];
      else $error = MODULE_PAYMENT_PAYPAL_EC_TEXT_GEN_ERROR;

      if (tep_session_is_registered('paypal_ec_token')) {
        $this->ec_gen_error('', true, true); //<-- Destroy existing token
      }

      return array('title' => MODULE_PAYMENT_PAYPAL_EC_TEXT_ERROR_HEADING,
                   'error' => $error);
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_PAYPAL_EC_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      $check_query = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Cancelled [PayPal EC IPN]' limit 1");
      if (tep_db_num_rows($check_query) < 1) {
        $status_query = tep_db_query("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
        $status = tep_db_fetch_array($status_query);

        $status_id = $status['status_id']+1;

        $languages = tep_get_languages();

        foreach ($languages as $lang) {
          tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_id . "', '" . $lang['id'] . "', 'Cancelled [PayPal EC IPN]')");
        }
      } else {
        $check = tep_db_fetch_array($check_query);

        $status_id = $check['orders_status_id'];
      }
      $check_query = tep_db_query("select orders_status_id from " . TABLE_ORDERS_STATUS . " where orders_status_name = 'Completed [PayPal EC IPN]' limit 1");
      if (tep_db_num_rows($check_query) < 1) {
        $status_query = tep_db_query("select max(orders_status_id) as status_id from " . TABLE_ORDERS_STATUS);
        $status = tep_db_fetch_array($status_query);

        $status_completed_id = $status['status_id']+1;

        $languages = tep_get_languages();

        foreach ($languages as $lang) {
          tep_db_query("insert into " . TABLE_ORDERS_STATUS . " (orders_status_id, language_id, orders_status_name) values ('" . $status_completed_id . "', '" . $lang['id'] . "', 'Completed [PayPal EC IPN]')");
        }
      } else {
        $check = tep_db_fetch_array($check_query);

        $status_completed_id = $check['orders_status_id'];
      }
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable PayPal Express Checkout IPN Module?', 'MODULE_PAYMENT_PAYPAL_EC_STATUS', 'False', 'Do you want to accept PayPal Express Checkout payments?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Live or Sandbox API?', 'MODULE_PAYMENT_PAYPAL_EC_SERVER', 'Sandbox', 'Live: Live transactions<br>Sandbox: For developers and testing', '6', '1', 'tep_cfg_select_option(array(\'Live\', \'Sandbox\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display:', 'MODULE_PAYMENT_PAYPAL_EC_SORT_ORDER', '1', 'Sort order of display. Lowest is displayed first.', '6', '2', now())");            
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Utilize Express Checkout Button?', 'MODULE_PAYMENT_PAYPAL_EC_BUTTON_INSTALLED', 'Yes', 'Do you want to show the Express Checkout Button in checkout shipping page? (RECOMMENDED: Yes)', '6', '3',  'tep_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Skip Confirmation Page?', 'MODULE_PAYMENT_PAYPAL_EC_SKIP_CONFIRMATION', 'No', 'Do you want to skip the confirmation page?', '6', '4',  'tep_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Accept Verified Accounts Only?', 'MODULE_PAYMENT_PAYPAL_EC_REQ_VERIFIED', 'Yes', 'Do you want to decline payments from unverified PayPal account owners? (RECOMMENDED: Yes)', '6', '5',  'tep_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Allow Edit Shipping Address at PayPal?', 'MODULE_PAYMENT_PAYPAL_EC_EDIT_ADDRESS', 'Yes', 'Do you want to allow customers to edit shipping address at PayPal? (RECOMMENDED: Yes)', '6', '6',  'tep_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Require Confirmed Shipping Address?', 'MODULE_PAYMENT_PAYPAL_EC_CONFIRM_ADDRESS', 'Yes', 'Do you want to require that your customers\' shipping address with PayPal is confirmed?', '6', '7',  'tep_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Skip Shipping Address?', 'MODULE_PAYMENT_PAYPAL_EC_SKIP_ADDRESS', 'No', 'Set this to Yes ONLY IF you don\'t want to send shipping address to PayPal.', '6', '8',  'tep_cfg_select_option(array(\'Yes\', \'No\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('API Username:', 'MODULE_PAYMENT_PAYPAL_API_USERNAME', '', 'Your Paypal API Username', '6', '9', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('API Password:', 'MODULE_PAYMENT_PAYPAL_API_PASSWORD', '', 'Your Paypal API Password', '6', '10', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('API Certificate:', 'MODULE_PAYMENT_PAYPAL_API_CERT_PATH', '" . DIR_FS_CATALOG . "cert_key_pem.txt', 'Type in the filename of your API certificate<br>(this must be an ABSOLUTE path)', '6', '11', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone:', 'MODULE_PAYMENT_PAYPAL_EC_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '12', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Currency:', 'MODULE_PAYMENT_PAYPAL_EC_CURRENCY', 'Selected Currency', 'The currency to use for transactions', '6', '13', 'tep_cfg_select_option(array(\'Selected Currency\',\'Only USD\',\'Only AUD\',\'Only CAD\',\'Only CHF\',\'Only CZK\',\'Only DKK\',\'Only EUR\',\'Only GBP\',\'Only HKD\',\'Only HUF\',\'Only JPY\',\'Only NOK\',\'Only NZD\',\'Only PLN\',\'Only SEK\',\'Only SGD\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Cancelled Order Status:', 'MODULE_PAYMENT_PAYPAL_EC_CANCELLED_ORDER_STATUS_ID', '" . $status_id . "', 'Set the status of orders made with this payment module when cancelled by customer', '6', '14', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Completed Order Status:', 'MODULE_PAYMENT_PAYPAL_EC_ORDER_STATUS_ID', '" . $status_completed_id . "', 'Set the status of orders made with this payment module, for payments with completed results', '6', '15', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Page Style:', 'MODULE_PAYMENT_PAYPAL_EC_PAGE_STYLE', 'PayPal', 'The page style to use for the transaction procedure (defined at your PayPal Profile page)', '6', '16', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Debug E-Mail Address:', 'MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL', '', 'A complete dump of failed transaction and all parameters of an Invalid IPN notification will be sent to this email address if one is entered.', '6', '17', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Send Every Transaction Dumping Email?', 'MODULE_PAYMENT_PAYPAL_EC_SUCCESS_EMAIL', 'False', 'Enable this option ONLY if you want to receive EVERY transaction\'s dumping to email. See install guide for more info.', '6', '18', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Proxy Address:', 'MODULE_PAYMENT_PAYPAL_EC_PROXY', '', 'If curl transactions need to go through a proxy, type the address here starting with http://. Otherwise, leave it blank.', '6', '19', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

   function keys() {
     return array('MODULE_PAYMENT_PAYPAL_EC_STATUS', 'MODULE_PAYMENT_PAYPAL_EC_SERVER', 'MODULE_PAYMENT_PAYPAL_EC_BUTTON_INSTALLED', 'MODULE_PAYMENT_PAYPAL_EC_SKIP_CONFIRMATION', 'MODULE_PAYMENT_PAYPAL_EC_REQ_VERIFIED', 'MODULE_PAYMENT_PAYPAL_EC_EDIT_ADDRESS', 'MODULE_PAYMENT_PAYPAL_EC_CONFIRM_ADDRESS', 'MODULE_PAYMENT_PAYPAL_EC_SKIP_ADDRESS', 'MODULE_PAYMENT_PAYPAL_API_USERNAME', 'MODULE_PAYMENT_PAYPAL_API_PASSWORD', 'MODULE_PAYMENT_PAYPAL_API_CERT_PATH', 'MODULE_PAYMENT_PAYPAL_EC_ZONE', 'MODULE_PAYMENT_PAYPAL_EC_CURRENCY', 'MODULE_PAYMENT_PAYPAL_EC_CANCELLED_ORDER_STATUS_ID', 'MODULE_PAYMENT_PAYPAL_EC_ORDER_STATUS_ID', 'MODULE_PAYMENT_PAYPAL_EC_PAGE_STYLE', 'MODULE_PAYMENT_PAYPAL_EC_DEBUG_EMAIL', 'MODULE_PAYMENT_PAYPAL_EC_SUCCESS_EMAIL', 'MODULE_PAYMENT_PAYPAL_EC_PROXY', 'MODULE_PAYMENT_PAYPAL_EC_SORT_ORDER');
   }
  }
?>